$TITLE MINLP4
* Algoritmo de Aproximacao Externa - Solucao do DIPCOPT++
* Kocis e Grossmann (1987)
$OFFSYMXREF
$OFFSYMLIST

VARIABLES Z;
POSITIVE VARIABLES X1, X2, X3;
BINARY VARIABLES Y1, Y2, Y3;
EQUATIONS CON1,CON2,CON3,CON4,OBJ;

CON1..     -Y1+0.9*log(1+X1)+1.08*log(1+X2)+0.9*X3=L=0;
CON2..     -10*Y2+log(1+X1)=L=0;
CON3..     -10*Y3+1.2*log(1+X2)=L=0;
CON4..     Y2+Y3-1=L=0;
OBJ..      Z=E=-2.9*X3-8.9*log(1+X1)-10.44*log(1+X2)+1.8*(X1+X2)+3.5*Y1+Y2+1.5*Y3;

* Limite Superior
*X1.UP=100;
*X2.UP=100;
*X3.UP=100;

* Limite Inferior
X1.LO=0;
X2.LO=0;
X3.LO=0;

* Valor Inicial
X1.L=0;
X2.L=0;
X3.L=1;
Y1.L=0;
Y2.L=1;
Y3.L=0;

MODEL MINLP4 / ALL / ;

*OPTION lp = osl;
OPTION lp = cplex;
OPTION nlp = conopt;
*OPTION nlp = minos5;
OPTION minlp = DICOPT;
*OPTION minlp = SBB;
OPTION sysout = on;

*MINLP4.optfile = 1;

SOLVE MINLP4 USING MINLP MINIMIZING Z;
